using System;
using System.Collections.Generic;
using jp.netgamers.free.tuogl;	//	OpenGL ̔bp[ڎwĂ
using jp.netgamers.free.tugame;	//	OpenGL ̃CuڎwĂ

class MyPrimitive
{
	public short[]	va;
	public uint[]	ca;

	public MyPrimitive( String path )
	{
		va = TUAssets.readTSVArray<short>( path + "/vertex.tsv" );
		ca = TUAssets.readTSVArray<uint>( path + "/color.tsv" );
	}

	public void draw( float x, float y, float z, float a )
	{
		GL1.VertexPointer( 3, va );	//	_W̐ݒ
		GL1.ColorPointer(			//	F̐ݒ
		 4,							//	F̗vf
		 GL1._UNSIGNED_BYTE,		//	f[^̌^
		 0,							//	f[^Ԋu
		 ca );						//	Ff[^

		GL1.PushMatrix();			//	}gbNXX^bNɊi[
		GL1.Translatef( x, y, z );	//	sړ
		GL1.Rotatef( a, 0, 0, 1 );	//	Zŉ]
		GL1.DrawArrays(				//	z`
		 GL1._TRIANGLES,			//	Op`̕`
		 0,							//	Jnʒu
		 va.Length / 3 );			//	_
		GL1.PopMatrix();			//	}gbNXX^bNo
	}

}

class MyModel
{
	public static String[]	Name = { "Akichi", "Building","Hatake","House","Azemichi","Jisya","Platform","Ekisya", "Rail","Train", "House3", "House2" };
	public static Dictionary<String, MyPrimitive>	Pri = new Dictionary<String, MyPrimitive>();

	public static void load()
	{
		foreach( String s in Name ){
			Pri[ s ] = new MyPrimitive( s );
		}
	}
}

class MyMap
{
	public static readonly sbyte AKICHI		= 0;
	public static readonly sbyte BUILDING	= 1;
	public static readonly sbyte HATAKE		= 2;
	public static readonly sbyte HOUSE		= 3;
	public static readonly sbyte AZEMICHI	= 4;
	public static readonly sbyte JISYA		= 5;
	public static readonly sbyte PLATFORM	= 6;
	public static readonly sbyte EKISYA		= 7;
	public static readonly sbyte RAIL		= 8;
	public static readonly sbyte TRAIN		= 9;
	public static readonly sbyte HOUSE3		= 10;
	public static readonly sbyte HOUSE2		= 11;

	public static int		Width, Height;
	public static sbyte[]	Data;
	public static sbyte[]	Angle;

	public static void draw()
	{
		for( int i = 0; i < Data.Length; i++ ){
			int		x = ( i % Width - 16 ) * 100;
			int		y = ( i / Width - 16 ) * 100;
			if( Data[ i ] == RAIL ){
				MyModel.Pri[ "Jisya" ].draw( x, y, 0, 0 );
				//	[`
				MyModel.Pri[ "Rail" ].draw( x, y - 11, 0, 0 );
				MyModel.Pri[ "Rail" ].draw( x, y + 11, 0, 0 );
				continue;
			}
			if( Data[ i ] == PLATFORM ){
				MyModel.Pri[ "Platform" ].draw( x, y, 0, Angle[ i ] * 22.5f );
				//	[`
				MyModel.Pri[ "Rail" ].draw( x, y - 11, 0, 0 );
				MyModel.Pri[ "Rail" ].draw( x, y + 11, 0, 0 );
				continue;
			}
			MyModel.Pri[ MyModel.Name[ Data[ i ] ] ].draw( x, y, 0, Angle[ i ] * 22.5f );
		}
	}

	public static void init( int width, int height )
	{
		Width = width;
		Height = height;

		Data = new sbyte[ Width * Height ];
		Angle = new sbyte[ Width * Height ];

		for( int i = 0; i < 10; i++ ){
			MyMap.Data[ TUGame.rnd( Height ) * Width + TUGame.rnd( Width ) ] = BUILDING;
		}

		for( int i = 0; i < 1000; i++ ){
			MyMap.Data[ TUGame.rnd( Height ) * Width + TUGame.rnd( Width ) ] = HATAKE;
		}

		for( int i = 0; i < 100; i++ ){
			MyMap.Data[ TUGame.rnd( Height ) * Width + TUGame.rnd( Width ) ] = HOUSE;
		}

		for( int i = 0; i < 100; i++ ){
			MyMap.Data[ TUGame.rnd( Height ) * Width + TUGame.rnd( Width ) ] = HOUSE3;
		}

		for( int i = 0; i < 100; i++ ){
			MyMap.Data[ TUGame.rnd( Height ) * Width + TUGame.rnd( Width ) ] = HOUSE2;
		}

		for( int y = 0; y < Height; y++ ){
			MyMap.Data[ y * Width + 16 ] = AZEMICHI;
			MyMap.Angle[ y * Width + 16 ] = 4;
		}

		for( int x = 0; x < Width; x++ ){
			MyMap.Data[ 16 * Width + x ] = RAIL;
			MyMap.Angle[ 16 * Width + x ] = 0;
		}

		for( int x = 10; x < 23; x++ ){
			MyMap.Data[ 16 * Width + x ] = PLATFORM;
			MyMap.Data[ 17 * Width + x ] = PLATFORM;
			MyMap.Angle[ 17 * Width + x ] = 8;
		}

		MyMap.Data[ 15 * Width + 16 ] = EKISYA;
		MyMap.Angle[ 15 * Width + 16 ] = 0;
	}
}

class ETrain : TURetroGame
{
	static float		PX;		//	vC[̍W
	static int			Score;		//	_
	static float		Mag = 1.0f;	//	{

	public override void wmCreated()
	{
		Title = "Edɏ낤";
		MyMap.init( 40, 40 );
		MyModel.load();
		setFrameRate( 60 );
	}

	public override void onMouseWheel( int d )
	{
		Mag += d / 4.0f;
		if( Mag < 0.5f )	Mag = 0.5f;
		if( Mag > 2.0f )	Mag = 2.0f;
	}

	public override void wmTimer()
	{
		Score++;
		PX += 2;
		Invalidate();	//	ĕ`˗
	}

	public override void wmDraw()
	{
		GL1.ClearColor( 0xff5544ee );	//	ʃNA̐Fw
		GL1.Clear(					//	ʃNA
		 GL1._DEPTH_BUFFER_BIT |	//	[xobt@
		 GL1._COLOR_BUFFER_BIT );	//	Fobt@
		GL1.LoadIdentity();			//	ftHg̃}gbNXǂݍ
		GL1.Scale( 0.0453f * Mag );	//	XP[ύXBglScalef( 0.0453f, 0.0453f, 0.0453f );
		GL1.LookAt(					//	_ݒ
		  -1,  -1,  0.817f,			//	J̈ʒu
		   0,   0,  0,				//	Jʂ̒
		   0,   0,  1 );			//	J̌

		GL1.Enable( GL1._DEPTH_TEST );	//	[xeXgL
		GL1.EnableClientState( GL1._COLOR_ARRAY );	//	FzL

		//	`
		MyMap.draw();

		//	Ԃ`
		for( int i = 0; i < 12; i++ ){
			MyModel.Pri[ "Train" ].draw( PX - i * 100, 0, 0, 0 );
		}

		GL1.DisableClientState( GL1._COLOR_ARRAY );	//	Fz𖳌
		GL1.Disable( GL1._DEPTH_TEST );
		GL1.LoadIdentity();				//	ftHg̃}gbNXǂݍ
		draw( "SCORE " + Score );
	}

	static void Main()
	{
		new ETrain();
	}
}
